# Hurry Curry! - a game about cooking
# Copyright (C) 2025 Hurry Curry! contributors
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License only.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
#
@abstract
class_name FloorLike
extends Tile

func _init(ctx: TileFactory.TileCC):
	super(ctx)
	if not base_mesh: ctx.floor_meshers[fm_id()].add_tile(ctx.position)

static func fm_id() -> String:
	return ""

static func floor_mesh() -> MeshInstance3D:
	var node = MeshInstance3D.new()
	return node
